/*
 * NE PAS DITER CE FICHIER - il est gnr par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_main_window (void)
{
  GtkWidget *main_window;
  GtkWidget *vbox1;
  GtkWidget *menubar;
  guint tmp_key;
  GtkWidget *file;
  GtkWidget *file_menu;
  GtkAccelGroup *file_menu_accels;
  GtkWidget *new;
  GtkWidget *open;
  GtkWidget *close;
  GtkWidget *save_as;
  GtkWidget *s_parateur7;
  GtkWidget *import;
  GtkWidget *import_menu;
  GtkAccelGroup *import_menu_accels;
  GtkWidget *import_text_file;
  GtkWidget *export;
  GtkWidget *export_menu;
  GtkAccelGroup *export_menu_accels;
  GtkWidget *export_entry;
  GtkWidget *export_everything_in_a_directory;
  GtkWidget *s_parateur6;
  GtkWidget *config;
  GtkWidget *s_parateur3;
  GtkWidget *quit;
  GtkWidget *edit;
  GtkWidget *edit_menu;
  GtkAccelGroup *edit_menu_accels;
  GtkWidget *add_entry;
  GtkWidget *delete_entry;
  GtkWidget *s_parateur4;
  GtkWidget *insert_entry_before;
  GtkWidget *insert_entry_after;
  GtkWidget *s_parateur8;
  GtkWidget *raise_entry;
  GtkWidget *lower_entry;
  GtkWidget *s_parateur9;
  GtkWidget *clear_entry;
  GtkWidget *help;
  GtkWidget *help_menu;
  GtkAccelGroup *help_menu_accels;
  GtkWidget *about;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button_quit;
  GtkWidget *button_new;
  GtkWidget *button_open;
  GtkWidget *button_save;
  GtkWidget *button_new_entry;
  GtkWidget *button_delete_entry;
  GtkWidget *button_about;
  GtkWidget *notebook;
  GtkWidget *vbox2;
  GtkWidget *scrolledwindow;
  GtkWidget *text;
  GtkWidget *statusbar;
  GtkWidget *label;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (main_window, "main_window");
  gtk_object_set_data (GTK_OBJECT (main_window), "main_window", main_window);
  gtk_window_set_default_size (GTK_WINDOW (main_window), 550, 300);
  gtk_window_set_policy (GTK_WINDOW (main_window), TRUE, TRUE, FALSE);
  gtk_window_set_wmclass (GTK_WINDOW (main_window), "main", "test");

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (main_window), vbox1);

  menubar = gtk_menu_bar_new ();
  gtk_widget_set_name (menubar, "menubar");
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "menubar", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar, FALSE, FALSE, 0);

  file = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (file)->child),
                                   _("_File"));
  gtk_widget_add_accelerator (file, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (file, "file");
  gtk_widget_ref (file);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file", file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file);
  gtk_container_add (GTK_CONTAINER (menubar), file);

  file_menu = gtk_menu_new ();
  gtk_widget_set_name (file_menu, "file_menu");
  gtk_widget_ref (file_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file_menu", file_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file), file_menu);
  file_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file_menu));

  new = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (new)->child),
                                   _("_New"));
  gtk_widget_add_accelerator (new, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (new, "new");
  gtk_widget_ref (new);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "new", new,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new);
  gtk_container_add (GTK_CONTAINER (file_menu), new);
  gtk_tooltips_set_tip (tooltips, new, _("New File"), NULL);
  gtk_widget_add_accelerator (new, "activate", accel_group,
                              GDK_N, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  open = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (open)->child),
                                   _("_Open"));
  gtk_widget_add_accelerator (open, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (open, "open");
  gtk_widget_ref (open);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "open", open,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open);
  gtk_container_add (GTK_CONTAINER (file_menu), open);
  gtk_tooltips_set_tip (tooltips, open, _("Open File"), NULL);
  gtk_widget_add_accelerator (open, "activate", accel_group,
                              GDK_O, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  close = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (close)->child),
                                   _("_Save"));
  gtk_widget_add_accelerator (close, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (close, "close");
  gtk_widget_ref (close);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "close", close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close);
  gtk_container_add (GTK_CONTAINER (file_menu), close);
  gtk_tooltips_set_tip (tooltips, close, _("Save File"), NULL);
  gtk_widget_add_accelerator (close, "activate", accel_group,
                              GDK_S, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  save_as = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (save_as)->child),
                                   _("Save _As"));
  gtk_widget_add_accelerator (save_as, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (save_as, "save_as");
  gtk_widget_ref (save_as);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_as", save_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_as);
  gtk_container_add (GTK_CONTAINER (file_menu), save_as);
  gtk_tooltips_set_tip (tooltips, save_as, _("Save The File As"), NULL);

  s_parateur7 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur7, "s_parateur7");
  gtk_widget_ref (s_parateur7);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "s_parateur7", s_parateur7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur7);
  gtk_container_add (GTK_CONTAINER (file_menu), s_parateur7);
  gtk_widget_set_sensitive (s_parateur7, FALSE);

  import = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (import)->child),
                                   _("_Import"));
  gtk_widget_add_accelerator (import, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (import, "import");
  gtk_widget_ref (import);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "import", import,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import);
  gtk_container_add (GTK_CONTAINER (file_menu), import);

  import_menu = gtk_menu_new ();
  gtk_widget_set_name (import_menu, "import_menu");
  gtk_widget_ref (import_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "import_menu", import_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (import), import_menu);
  import_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (import_menu));

  import_text_file = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (import_text_file)->child),
                                   _("Import _Text File"));
  gtk_widget_add_accelerator (import_text_file, "activate_item", import_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (import_text_file, "import_text_file");
  gtk_widget_ref (import_text_file);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "import_text_file", import_text_file,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_text_file);
  gtk_container_add (GTK_CONTAINER (import_menu), import_text_file);
  gtk_tooltips_set_tip (tooltips, import_text_file, _("Import A Text File"), NULL);

  export = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (export)->child),
                                   _("_Export"));
  gtk_widget_add_accelerator (export, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (export, "export");
  gtk_widget_ref (export);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export", export,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (export);
  gtk_container_add (GTK_CONTAINER (file_menu), export);

  export_menu = gtk_menu_new ();
  gtk_widget_set_name (export_menu, "export_menu");
  gtk_widget_ref (export_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export_menu", export_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (export), export_menu);
  export_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (export_menu));

  export_entry = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (export_entry)->child),
                                   _("Export Entry As _Text"));
  gtk_widget_add_accelerator (export_entry, "activate_item", export_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (export_entry, "export_entry");
  gtk_widget_ref (export_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export_entry", export_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (export_entry);
  gtk_container_add (GTK_CONTAINER (export_menu), export_entry);
  gtk_tooltips_set_tip (tooltips, export_entry, _("Export The Current Entry In A Text File"), NULL);

  export_everything_in_a_directory = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (export_everything_in_a_directory)->child),
                                   _("Export Everything In A _Directory"));
  gtk_widget_add_accelerator (export_everything_in_a_directory, "activate_item", export_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (export_everything_in_a_directory, "export_everything_in_a_directory");
  gtk_widget_ref (export_everything_in_a_directory);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export_everything_in_a_directory", export_everything_in_a_directory,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (export_everything_in_a_directory);
  gtk_container_add (GTK_CONTAINER (export_menu), export_everything_in_a_directory);
  gtk_tooltips_set_tip (tooltips, export_everything_in_a_directory, _("Export All The Entries In A Directory"), NULL);

  s_parateur6 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur6, "s_parateur6");
  gtk_widget_ref (s_parateur6);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "s_parateur6", s_parateur6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur6);
  gtk_container_add (GTK_CONTAINER (file_menu), s_parateur6);
  gtk_widget_set_sensitive (s_parateur6, FALSE);

  config = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (config)->child),
                                   _("_Config"));
  gtk_widget_add_accelerator (config, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (config, "config");
  gtk_widget_ref (config);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "config", config,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (config);
  gtk_container_add (GTK_CONTAINER (file_menu), config);
  gtk_tooltips_set_tip (tooltips, config, _("Edit The Gtklepin Configuration"), NULL);
  gtk_widget_add_accelerator (config, "activate", accel_group,
                              GDK_C, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  s_parateur3 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur3, "s_parateur3");
  gtk_widget_ref (s_parateur3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "s_parateur3", s_parateur3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur3);
  gtk_container_add (GTK_CONTAINER (file_menu), s_parateur3);
  gtk_widget_set_sensitive (s_parateur3, FALSE);

  quit = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (quit)->child),
                                   _("_Quit"));
  gtk_widget_add_accelerator (quit, "activate_item", file_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (quit, "quit");
  gtk_widget_ref (quit);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "quit", quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit);
  gtk_container_add (GTK_CONTAINER (file_menu), quit);
  gtk_tooltips_set_tip (tooltips, quit, _("Quit Gtklepin"), NULL);
  gtk_widget_add_accelerator (quit, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  edit = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (edit)->child),
                                   _("_Edit"));
  gtk_widget_add_accelerator (edit, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (edit, "edit");
  gtk_widget_ref (edit);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit", edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit);
  gtk_container_add (GTK_CONTAINER (menubar), edit);

  edit_menu = gtk_menu_new ();
  gtk_widget_set_name (edit_menu, "edit_menu");
  gtk_widget_ref (edit_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit_menu", edit_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (edit), edit_menu);
  edit_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (edit_menu));

  add_entry = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (add_entry)->child),
                                   _("_New Entry"));
  gtk_widget_add_accelerator (add_entry, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (add_entry, "add_entry");
  gtk_widget_ref (add_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "add_entry", add_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_entry);
  gtk_container_add (GTK_CONTAINER (edit_menu), add_entry);
  gtk_tooltips_set_tip (tooltips, add_entry, _("Insert A New Entry"), NULL);
  gtk_widget_add_accelerator (add_entry, "activate", accel_group,
                              GDK_A, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  delete_entry = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (delete_entry)->child),
                                   _("_Delete Current Entry"));
  gtk_widget_add_accelerator (delete_entry, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (delete_entry, "delete_entry");
  gtk_widget_ref (delete_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete_entry", delete_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_entry);
  gtk_container_add (GTK_CONTAINER (edit_menu), delete_entry);
  gtk_tooltips_set_tip (tooltips, delete_entry, _("Delete The Current Entry"), NULL);
  gtk_widget_add_accelerator (delete_entry, "activate", accel_group,
                              GDK_D, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  s_parateur4 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur4, "s_parateur4");
  gtk_widget_ref (s_parateur4);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "s_parateur4", s_parateur4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur4);
  gtk_container_add (GTK_CONTAINER (edit_menu), s_parateur4);
  gtk_widget_set_sensitive (s_parateur4, FALSE);

  insert_entry_before = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (insert_entry_before)->child),
                                   _("Insert Entry _Before"));
  gtk_widget_add_accelerator (insert_entry_before, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (insert_entry_before, "insert_entry_before");
  gtk_widget_ref (insert_entry_before);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "insert_entry_before", insert_entry_before,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (insert_entry_before);
  gtk_container_add (GTK_CONTAINER (edit_menu), insert_entry_before);
  gtk_tooltips_set_tip (tooltips, insert_entry_before, _("Insert A New Entry Before The Current One"), NULL);

  insert_entry_after = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (insert_entry_after)->child),
                                   _("Insert Entry _After"));
  gtk_widget_add_accelerator (insert_entry_after, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (insert_entry_after, "insert_entry_after");
  gtk_widget_ref (insert_entry_after);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "insert_entry_after", insert_entry_after,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (insert_entry_after);
  gtk_container_add (GTK_CONTAINER (edit_menu), insert_entry_after);
  gtk_tooltips_set_tip (tooltips, insert_entry_after, _("Insert A New Entry After The Current One"), NULL);

  s_parateur8 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur8, "s_parateur8");
  gtk_widget_ref (s_parateur8);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "s_parateur8", s_parateur8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur8);
  gtk_container_add (GTK_CONTAINER (edit_menu), s_parateur8);
  gtk_widget_set_sensitive (s_parateur8, FALSE);

  raise_entry = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (raise_entry)->child),
                                   _("_Raise Entry"));
  gtk_widget_add_accelerator (raise_entry, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (raise_entry, "raise_entry");
  gtk_widget_ref (raise_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "raise_entry", raise_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (raise_entry);
  gtk_container_add (GTK_CONTAINER (edit_menu), raise_entry);
  gtk_tooltips_set_tip (tooltips, raise_entry, _("Raise The Current Entry"), NULL);
  gtk_widget_add_accelerator (raise_entry, "activate", accel_group,
                              GDK_R, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  lower_entry = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (lower_entry)->child),
                                   _("_Lower Entry"));
  gtk_widget_add_accelerator (lower_entry, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (lower_entry, "lower_entry");
  gtk_widget_ref (lower_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "lower_entry", lower_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lower_entry);
  gtk_container_add (GTK_CONTAINER (edit_menu), lower_entry);
  gtk_tooltips_set_tip (tooltips, lower_entry, _("Lower The Current Entry"), NULL);
  gtk_widget_add_accelerator (lower_entry, "activate", accel_group,
                              GDK_L, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  s_parateur9 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur9, "s_parateur9");
  gtk_widget_ref (s_parateur9);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "s_parateur9", s_parateur9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur9);
  gtk_container_add (GTK_CONTAINER (edit_menu), s_parateur9);
  gtk_widget_set_sensitive (s_parateur9, FALSE);

  clear_entry = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (clear_entry)->child),
                                   _("_Clear Entry"));
  gtk_widget_add_accelerator (clear_entry, "activate_item", edit_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (clear_entry, "clear_entry");
  gtk_widget_ref (clear_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "clear_entry", clear_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clear_entry);
  gtk_container_add (GTK_CONTAINER (edit_menu), clear_entry);

  help = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (help)->child),
                                   _("_Help"));
  gtk_widget_add_accelerator (help, "activate_item", accel_group,
                              tmp_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (help, "help");
  gtk_widget_ref (help);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help", help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help);
  gtk_container_add (GTK_CONTAINER (menubar), help);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (help));

  help_menu = gtk_menu_new ();
  gtk_widget_set_name (help_menu, "help_menu");
  gtk_widget_ref (help_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help_menu", help_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help), help_menu);
  help_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help_menu));

  about = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about)->child),
                                   _("_About"));
  gtk_widget_add_accelerator (about, "activate_item", help_menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (about, "about");
  gtk_widget_ref (about);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about", about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about);
  gtk_container_add (GTK_CONTAINER (help_menu), about);
  gtk_tooltips_set_tip (tooltips, about, _("About Gtklepin"), NULL);
  gtk_widget_add_accelerator (about, "activate", accel_group,
                              GDK_B, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_set_name (toolbar, "toolbar");
  gtk_widget_ref (toolbar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "toolbar", toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar);
  gtk_box_pack_start (GTK_BOX (vbox1), toolbar, FALSE, FALSE, 0);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_HALF);

  tmp_toolbar_icon = create_pixmap (main_window, "exit.xpm");
  button_quit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Quit"),
                                _("Quit Gtklepin"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_quit, "button_quit");
  gtk_widget_ref (button_quit);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_quit", button_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_quit);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = create_pixmap (main_window, "new.xpm");
  button_new = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("New"),
                                _("New File"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_new, "button_new");
  gtk_widget_ref (button_new);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_new", button_new,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_new);

  tmp_toolbar_icon = create_pixmap (main_window, "open.xpm");
  button_open = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Open"),
                                _("Open File"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_open, "button_open");
  gtk_widget_ref (button_open);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_open", button_open,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_open);

  tmp_toolbar_icon = create_pixmap (main_window, "save.xpm");
  button_save = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Save"),
                                _("Save File"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_save, "button_save");
  gtk_widget_ref (button_save);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_save", button_save,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_save);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = create_pixmap (main_window, "insert.xpm");
  button_new_entry = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("New Entry"),
                                _("Insert A New Entry"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_new_entry, "button_new_entry");
  gtk_widget_ref (button_new_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_new_entry", button_new_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_new_entry);

  tmp_toolbar_icon = create_pixmap (main_window, "delete.xpm");
  button_delete_entry = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Delete Entry"),
                                _("Delete The Current Entry"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_delete_entry, "button_delete_entry");
  gtk_widget_ref (button_delete_entry);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_delete_entry", button_delete_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_delete_entry);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = create_pixmap (main_window, "about.xpm");
  button_about = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("About"),
                                _("About Gtklepin"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_name (button_about, "button_about");
  gtk_widget_ref (button_about);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_about", button_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_about);

  notebook = gtk_notebook_new ();
  gtk_widget_set_name (notebook, "notebook");
  gtk_widget_ref (notebook);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "notebook", notebook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook);
  gtk_box_pack_start (GTK_BOX (vbox1), notebook, TRUE, TRUE, 0);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_RIGHT);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook), TRUE);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook), vbox2);

  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow, "scrolledwindow");
  gtk_widget_ref (scrolledwindow);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow", scrolledwindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  text = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (text, "text");
  gtk_widget_ref (text);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "text", text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow), text);
  gtk_text_set_editable (GTK_TEXT (text), TRUE);

  statusbar = gtk_statusbar_new ();
  gtk_widget_set_name (statusbar, "statusbar");
  gtk_widget_ref (statusbar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "statusbar", statusbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar);
  gtk_box_pack_start (GTK_BOX (vbox2), statusbar, FALSE, FALSE, 0);

  label = gtk_label_new ("");
  gtk_widget_set_name (label, "label");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 0), label);

  gtk_signal_connect_after (GTK_OBJECT (main_window), "delete_event",
                            GTK_SIGNAL_FUNC (on_main_window_delete_event),
                            NULL);
  gtk_signal_connect (GTK_OBJECT (main_window), "destroy_event",
                      GTK_SIGNAL_FUNC (on_main_window_destroy_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (new), "activate",
                      GTK_SIGNAL_FUNC (on_new_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (open), "activate",
                      GTK_SIGNAL_FUNC (on_open_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (close), "activate",
                      GTK_SIGNAL_FUNC (on_save_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (save_as), "activate",
                      GTK_SIGNAL_FUNC (on_save_as_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (import_text_file), "activate",
                      GTK_SIGNAL_FUNC (on_import_text_file_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (export_entry), "activate",
                      GTK_SIGNAL_FUNC (on_export_entry_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (export_everything_in_a_directory), "activate",
                      GTK_SIGNAL_FUNC (on_export_everything_in_a_directory_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (config), "activate",
                      GTK_SIGNAL_FUNC (on_config_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit), "activate",
                      GTK_SIGNAL_FUNC (on_quit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (add_entry), "activate",
                      GTK_SIGNAL_FUNC (on_add_entry_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (delete_entry), "activate",
                      GTK_SIGNAL_FUNC (on_delete_entry_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (insert_entry_before), "activate",
                      GTK_SIGNAL_FUNC (on_insert_entry_before_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (insert_entry_after), "activate",
                      GTK_SIGNAL_FUNC (on_insert_entry_after_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (raise_entry), "activate",
                      GTK_SIGNAL_FUNC (on_raise_entry_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (lower_entry), "activate",
                      GTK_SIGNAL_FUNC (on_lower_entry_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clear_entry), "activate",
                      GTK_SIGNAL_FUNC (on_clear_entry_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about), "activate",
                      GTK_SIGNAL_FUNC (on_about_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_quit), "clicked",
                      GTK_SIGNAL_FUNC (on_button_quit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_new), "clicked",
                      GTK_SIGNAL_FUNC (on_button_new_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_open), "clicked",
                      GTK_SIGNAL_FUNC (on_button_open_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_save), "clicked",
                      GTK_SIGNAL_FUNC (on_button_save_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_new_entry), "clicked",
                      GTK_SIGNAL_FUNC (on_button_new_entry_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_delete_entry), "clicked",
                      GTK_SIGNAL_FUNC (on_button_delete_entry_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_about), "clicked",
                      GTK_SIGNAL_FUNC (on_button_about_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (notebook), "switch_page",
                      GTK_SIGNAL_FUNC (on_notebook_switch_page),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (text), "changed",
                      GTK_SIGNAL_FUNC (on_text_changed),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (main_window), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (main_window), accel_group);

  return main_window;
}

GtkWidget*
create_options_window (void)
{
  GtkWidget *options_window;
  GtkWidget *options_vbox;
  GtkWidget *notebook_options;
  GtkWidget *vbox3;
  GtkWidget *checkbutton_openlast;
  GtkWidget *checkbutton_linewarp;
  GtkWidget *frame1;
  GtkWidget *table1;
  GSList *table1_group = NULL;
  GtkWidget *radiobutton_left;
  GtkWidget *radiobutton_right;
  GtkWidget *radiobutton_top;
  GtkWidget *radiobutton_bottom;
  GtkWidget *frame;
  GtkWidget *vbox_frame;
  GtkWidget *checkbutton_toolbar;
  GtkWidget *hseparator_frame;
  GtkWidget *label_toolbar;
  GtkWidget *hbox1;
  GSList *hbox1_group = NULL;
  GtkWidget *radiobutton_both;
  GtkWidget *radiobutton_pictures;
  GtkWidget *radiobutton_text;
  GtkWidget *label_options;
  GtkWidget *vbox_about;
  GtkWidget *label_about2;
  GtkWidget *scrolledwindow_gpl;
  GtkWidget *text_gpl;
  GtkWidget *label_about;
  GtkWidget *hbuttonbox;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;

  options_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_name (options_window, "options_window");
  gtk_object_set_data (GTK_OBJECT (options_window), "options_window", options_window);
  gtk_window_set_title (GTK_WINDOW (options_window), _("Options"));
  gtk_window_set_position (GTK_WINDOW (options_window), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (options_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (options_window), FALSE, FALSE, FALSE);
  gtk_window_set_wmclass (GTK_WINDOW (options_window), "options", "test");

  options_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (options_vbox, "options_vbox");
  gtk_widget_ref (options_vbox);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "options_vbox", options_vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (options_vbox);
  gtk_container_add (GTK_CONTAINER (options_window), options_vbox);

  notebook_options = gtk_notebook_new ();
  gtk_widget_set_name (notebook_options, "notebook_options");
  gtk_widget_ref (notebook_options);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "notebook_options", notebook_options,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook_options);
  gtk_box_pack_start (GTK_BOX (options_vbox), notebook_options, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook_options), 5);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook_options), TRUE);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (notebook_options), vbox3);

  checkbutton_openlast = gtk_check_button_new_with_label (_("Open Last File When Starting"));
  gtk_widget_set_name (checkbutton_openlast, "checkbutton_openlast");
  gtk_widget_ref (checkbutton_openlast);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "checkbutton_openlast", checkbutton_openlast,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_openlast);
  gtk_box_pack_start (GTK_BOX (vbox3), checkbutton_openlast, TRUE, FALSE, 0);

  checkbutton_linewarp = gtk_check_button_new_with_label (_("Line Wrap"));
  gtk_widget_set_name (checkbutton_linewarp, "checkbutton_linewarp");
  gtk_widget_ref (checkbutton_linewarp);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "checkbutton_linewarp", checkbutton_linewarp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_linewarp);
  gtk_box_pack_start (GTK_BOX (vbox3), checkbutton_linewarp, FALSE, FALSE, 0);

  frame1 = gtk_frame_new (_("Notebook Tabs Position:"));
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox3), frame1, FALSE, FALSE, 4);

  table1 = gtk_table_new (3, 3, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame1), table1);

  radiobutton_left = gtk_radio_button_new_with_label (table1_group, _("Left"));
  table1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_left));
  gtk_widget_set_name (radiobutton_left, "radiobutton_left");
  gtk_widget_ref (radiobutton_left);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_left", radiobutton_left,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_left);
  gtk_table_attach (GTK_TABLE (table1), radiobutton_left, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radiobutton_right = gtk_radio_button_new_with_label (table1_group, _("Right"));
  table1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_right));
  gtk_widget_set_name (radiobutton_right, "radiobutton_right");
  gtk_widget_ref (radiobutton_right);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_right", radiobutton_right,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_right);
  gtk_table_attach (GTK_TABLE (table1), radiobutton_right, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radiobutton_top = gtk_radio_button_new_with_label (table1_group, _("Top"));
  table1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_top));
  gtk_widget_set_name (radiobutton_top, "radiobutton_top");
  gtk_widget_ref (radiobutton_top);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_top", radiobutton_top,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_top);
  gtk_table_attach (GTK_TABLE (table1), radiobutton_top, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radiobutton_bottom = gtk_radio_button_new_with_label (table1_group, _("Bottom"));
  table1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_bottom));
  gtk_widget_set_name (radiobutton_bottom, "radiobutton_bottom");
  gtk_widget_ref (radiobutton_bottom);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_bottom", radiobutton_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_bottom);
  gtk_table_attach (GTK_TABLE (table1), radiobutton_bottom, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame = gtk_frame_new (_("Toolbar"));
  gtk_widget_set_name (frame, "frame");
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox3), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);

  vbox_frame = gtk_vbox_new (TRUE, 0);
  gtk_widget_set_name (vbox_frame, "vbox_frame");
  gtk_widget_ref (vbox_frame);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "vbox_frame", vbox_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_frame);
  gtk_container_add (GTK_CONTAINER (frame), vbox_frame);

  checkbutton_toolbar = gtk_check_button_new_with_label (_("Show Toolbar"));
  gtk_widget_set_name (checkbutton_toolbar, "checkbutton_toolbar");
  gtk_widget_ref (checkbutton_toolbar);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "checkbutton_toolbar", checkbutton_toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton_toolbar);
  gtk_box_pack_start (GTK_BOX (vbox_frame), checkbutton_toolbar, FALSE, FALSE, 0);

  hseparator_frame = gtk_hseparator_new ();
  gtk_widget_set_name (hseparator_frame, "hseparator_frame");
  gtk_widget_ref (hseparator_frame);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "hseparator_frame", hseparator_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator_frame);
  gtk_box_pack_start (GTK_BOX (vbox_frame), hseparator_frame, FALSE, FALSE, 0);

  label_toolbar = gtk_label_new (_("Show Toolbar As:"));
  gtk_widget_set_name (label_toolbar, "label_toolbar");
  gtk_widget_ref (label_toolbar);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "label_toolbar", label_toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_toolbar);
  gtk_box_pack_start (GTK_BOX (vbox_frame), label_toolbar, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_toolbar), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_toolbar), 7.45058e-09, 7.45058e-09);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox_frame), hbox1, FALSE, FALSE, 0);

  radiobutton_both = gtk_radio_button_new_with_label (hbox1_group, _("Pictures And Text"));
  hbox1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_both));
  gtk_widget_set_name (radiobutton_both, "radiobutton_both");
  gtk_widget_ref (radiobutton_both);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_both", radiobutton_both,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_both);
  gtk_box_pack_start (GTK_BOX (hbox1), radiobutton_both, FALSE, FALSE, 0);

  radiobutton_pictures = gtk_radio_button_new_with_label (hbox1_group, _("Pictures Only"));
  hbox1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_pictures));
  gtk_widget_set_name (radiobutton_pictures, "radiobutton_pictures");
  gtk_widget_ref (radiobutton_pictures);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_pictures", radiobutton_pictures,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_pictures);
  gtk_box_pack_start (GTK_BOX (hbox1), radiobutton_pictures, FALSE, FALSE, 0);

  radiobutton_text = gtk_radio_button_new_with_label (hbox1_group, _("Text Only"));
  hbox1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_text));
  gtk_widget_set_name (radiobutton_text, "radiobutton_text");
  gtk_widget_ref (radiobutton_text);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "radiobutton_text", radiobutton_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_text);
  gtk_box_pack_start (GTK_BOX (hbox1), radiobutton_text, FALSE, FALSE, 0);

  label_options = gtk_label_new (_("Options"));
  gtk_widget_set_name (label_options, "label_options");
  gtk_widget_ref (label_options);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "label_options", label_options,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_options);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_options), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_options), 0), label_options);

  vbox_about = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox_about, "vbox_about");
  gtk_widget_ref (vbox_about);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "vbox_about", vbox_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_about);
  gtk_container_add (GTK_CONTAINER (notebook_options), vbox_about);

  label_about2 = gtk_label_new (_("gtklepin\nhttp://ordiluc.net/gtklepin\n\n(c) 2002 Luc Dufresne\nluc@ordiluc.net"));
  gtk_widget_set_name (label_about2, "label_about2");
  gtk_widget_ref (label_about2);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "label_about2", label_about2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_about2);
  gtk_box_pack_start (GTK_BOX (vbox_about), label_about2, FALSE, FALSE, 0);

  scrolledwindow_gpl = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow_gpl, "scrolledwindow_gpl");
  gtk_widget_ref (scrolledwindow_gpl);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "scrolledwindow_gpl", scrolledwindow_gpl,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow_gpl);
  gtk_box_pack_start (GTK_BOX (vbox_about), scrolledwindow_gpl, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow_gpl, 480, -2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_gpl), GTK_POLICY_NEVER, GTK_POLICY_NEVER);

  text_gpl = gtk_text_new (NULL, NULL);
  gtk_widget_set_name (text_gpl, "text_gpl");
  gtk_widget_ref (text_gpl);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "text_gpl", text_gpl,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_gpl);
  gtk_container_add (GTK_CONTAINER (scrolledwindow_gpl), text_gpl);
  gtk_text_insert (GTK_TEXT (text_gpl), NULL, NULL, NULL,
                   _("This program is free software; you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation; either version 2 of the License, or\n(at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License\nalong with this program; if not, write to the Free Software\nFoundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"), 675);

  label_about = gtk_label_new (_("About"));
  gtk_widget_set_name (label_about, "label_about");
  gtk_widget_ref (label_about);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "label_about", label_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_about);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_options), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_options), 1), label_about);

  hbuttonbox = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox, "hbuttonbox");
  gtk_widget_ref (hbuttonbox);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "hbuttonbox", hbuttonbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox);
  gtk_box_pack_start (GTK_BOX (options_vbox), hbuttonbox, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox), GTK_BUTTONBOX_SPREAD);

  button_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (button_ok, "button_ok");
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox), button_ok);
  GTK_WIDGET_SET_FLAGS (button_ok, GTK_CAN_DEFAULT);

  button_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (button_cancel, "button_cancel");
  gtk_widget_ref (button_cancel);
  gtk_object_set_data_full (GTK_OBJECT (options_window), "button_cancel", button_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox), button_cancel);
  GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (options_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_options_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (checkbutton_linewarp), "toggled",
                      GTK_SIGNAL_FUNC (on_checkbutton_linewarp_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_left), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_left_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_right), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_right_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_top), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_top_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_bottom), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_bottom_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (checkbutton_toolbar), "toggled",
                      GTK_SIGNAL_FUNC (on_checkbutton_toolbar_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_both), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_both_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_pictures), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_pictures_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_text), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_text_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_button_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_button_cancel_clicked),
                      NULL);

  return options_window;
}

GtkWidget*
create_fileselection (void)
{
  GtkWidget *fileselection;
  GtkWidget *file_ok_button;
  GtkWidget *file_cancel_button;

  fileselection = gtk_file_selection_new (_("Chose a file"));
  gtk_widget_set_name (fileselection, "fileselection");
  gtk_object_set_data (GTK_OBJECT (fileselection), "fileselection", fileselection);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);
  GTK_WINDOW (fileselection)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (fileselection), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (fileselection), TRUE);

  file_ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
  gtk_widget_set_name (file_ok_button, "file_ok_button");
  gtk_object_set_data (GTK_OBJECT (fileselection), "file_ok_button", file_ok_button);
  gtk_widget_show (file_ok_button);
  GTK_WIDGET_SET_FLAGS (file_ok_button, GTK_CAN_DEFAULT);

  file_cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
  gtk_widget_set_name (file_cancel_button, "file_cancel_button");
  gtk_object_set_data (GTK_OBJECT (fileselection), "file_cancel_button", file_cancel_button);
  gtk_widget_show (file_cancel_button);
  GTK_WIDGET_SET_FLAGS (file_cancel_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (fileselection), "delete_event",
                      GTK_SIGNAL_FUNC (on_fileselection_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (file_ok_button), "clicked",
                      GTK_SIGNAL_FUNC (on_file_ok_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (file_cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_file_cancel_button_clicked),
                      NULL);

  return fileselection;
}

GtkWidget*
create_dialog_save (void)
{
  GtkWidget *dialog_save;
  GtkWidget *dialog_vbox1;
  GtkWidget *label2;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button_yes;
  GtkWidget *button_no;
  GtkWidget *button_save_cancel;

  dialog_save = gtk_dialog_new ();
  gtk_widget_set_name (dialog_save, "dialog_save");
  gtk_object_set_data (GTK_OBJECT (dialog_save), "dialog_save", dialog_save);
  gtk_window_set_title (GTK_WINDOW (dialog_save), _("Save File ?"));
  GTK_WINDOW (dialog_save)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (dialog_save), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (dialog_save), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_save), FALSE, FALSE, FALSE);
  gtk_window_set_wmclass (GTK_WINDOW (dialog_save), "ask_save", "test");

  dialog_vbox1 = GTK_DIALOG (dialog_save)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (dialog_save), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  label2 = gtk_label_new (_("The file was not saved.\nShould I save it now ?"));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (dialog_save), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label2, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label2), 0, 10);

  dialog_action_area1 = GTK_DIALOG (dialog_save)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (dialog_save), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox1, "hbuttonbox1");
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_save), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);

  button_yes = gtk_button_new_with_label (_("Yes"));
  gtk_widget_set_name (button_yes, "button_yes");
  gtk_widget_ref (button_yes);
  gtk_object_set_data_full (GTK_OBJECT (dialog_save), "button_yes", button_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_yes);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_yes);
  GTK_WIDGET_SET_FLAGS (button_yes, GTK_CAN_DEFAULT);

  button_no = gtk_button_new_with_label (_("No"));
  gtk_widget_set_name (button_no, "button_no");
  gtk_widget_ref (button_no);
  gtk_object_set_data_full (GTK_OBJECT (dialog_save), "button_no", button_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_no);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_no);
  GTK_WIDGET_SET_FLAGS (button_no, GTK_CAN_DEFAULT);

  button_save_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_set_name (button_save_cancel, "button_save_cancel");
  gtk_widget_ref (button_save_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog_save), "button_save_cancel", button_save_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_save_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_save_cancel);
  GTK_WIDGET_SET_FLAGS (button_save_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (dialog_save), "delete_event",
                      GTK_SIGNAL_FUNC (on_dialog_save_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_yes), "clicked",
                      GTK_SIGNAL_FUNC (on_button_yes_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_no), "clicked",
                      GTK_SIGNAL_FUNC (on_button_no_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_save_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_button_save_cancel_clicked),
                      NULL);

  return dialog_save;
}

GtkWidget*
create_message_dialog (void)
{
  GtkWidget *message_dialog;
  GtkWidget *dialog_vbox2;
  GtkWidget *message_dialog_label;
  GtkWidget *dialog_action_area2;
  GtkWidget *message_dialog_ok_button;

  message_dialog = gtk_dialog_new ();
  gtk_widget_set_name (message_dialog, "message_dialog");
  gtk_object_set_data (GTK_OBJECT (message_dialog), "message_dialog", message_dialog);
  gtk_window_set_title (GTK_WINDOW (message_dialog), _("dialog1"));
  GTK_WINDOW (message_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (message_dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (message_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (message_dialog), FALSE, FALSE, FALSE);
  gtk_window_set_wmclass (GTK_WINDOW (message_dialog), "message", "test");

  dialog_vbox2 = GTK_DIALOG (message_dialog)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (message_dialog), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  message_dialog_label = gtk_label_new ("");
  gtk_widget_set_name (message_dialog_label, "message_dialog_label");
  gtk_widget_ref (message_dialog_label);
  gtk_object_set_data_full (GTK_OBJECT (message_dialog), "message_dialog_label", message_dialog_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_dialog_label);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), message_dialog_label, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (message_dialog_label), 10, 10);

  dialog_action_area2 = GTK_DIALOG (message_dialog)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (message_dialog), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  message_dialog_ok_button = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (message_dialog_ok_button, "message_dialog_ok_button");
  gtk_widget_ref (message_dialog_ok_button);
  gtk_object_set_data_full (GTK_OBJECT (message_dialog), "message_dialog_ok_button", message_dialog_ok_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_dialog_ok_button);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), message_dialog_ok_button, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (message_dialog_ok_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (message_dialog_ok_button), "clicked",
                      GTK_SIGNAL_FUNC (on_message_dialog_ok_button_clicked),
                      NULL);

  gtk_widget_grab_default (message_dialog_ok_button);
  return message_dialog;
}

GtkWidget*
create_ask_dialog (void)
{
  GtkWidget *ask_dialog;
  GtkWidget *vbox4;
  GtkWidget *ask_dialog_label;
  GtkWidget *hbox2;
  GtkWidget *ask_button_yes;
  GtkWidget *ask_button_no;

  ask_dialog = gtk_dialog_new ();
  gtk_widget_set_name (ask_dialog, "ask_dialog");
  gtk_object_set_data (GTK_OBJECT (ask_dialog), "ask_dialog", ask_dialog);
  GTK_WINDOW (ask_dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (ask_dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (ask_dialog), TRUE);
  gtk_window_set_policy (GTK_WINDOW (ask_dialog), FALSE, FALSE, FALSE);
  gtk_window_set_wmclass (GTK_WINDOW (ask_dialog), "message", "test");

  vbox4 = GTK_DIALOG (ask_dialog)->vbox;
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_object_set_data (GTK_OBJECT (ask_dialog), "vbox4", vbox4);
  gtk_widget_show (vbox4);

  ask_dialog_label = gtk_label_new ("");
  gtk_widget_set_name (ask_dialog_label, "ask_dialog_label");
  gtk_widget_ref (ask_dialog_label);
  gtk_object_set_data_full (GTK_OBJECT (ask_dialog), "ask_dialog_label", ask_dialog_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ask_dialog_label);
  gtk_box_pack_start (GTK_BOX (vbox4), ask_dialog_label, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (ask_dialog_label), 10, 10);

  hbox2 = GTK_DIALOG (ask_dialog)->action_area;
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_object_set_data (GTK_OBJECT (ask_dialog), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 10);

  ask_button_yes = gtk_button_new_with_label (_("Yes"));
  gtk_widget_set_name (ask_button_yes, "ask_button_yes");
  gtk_widget_ref (ask_button_yes);
  gtk_object_set_data_full (GTK_OBJECT (ask_dialog), "ask_button_yes", ask_button_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ask_button_yes);
  gtk_box_pack_start (GTK_BOX (hbox2), ask_button_yes, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (ask_button_yes, GTK_CAN_DEFAULT);

  ask_button_no = gtk_button_new_with_label (_("No"));
  gtk_widget_set_name (ask_button_no, "ask_button_no");
  gtk_widget_ref (ask_button_no);
  gtk_object_set_data_full (GTK_OBJECT (ask_dialog), "ask_button_no", ask_button_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ask_button_no);
  gtk_box_pack_start (GTK_BOX (hbox2), ask_button_no, FALSE, FALSE, 0);
  GTK_WIDGET_SET_FLAGS (ask_button_no, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (ask_dialog), "delete_event",
                      GTK_SIGNAL_FUNC (on_ask_dialog_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ask_button_yes), "clicked",
                      GTK_SIGNAL_FUNC (on_ask_button_yes_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ask_button_no), "clicked",
                      GTK_SIGNAL_FUNC (on_ask_button_no_clicked),
                      NULL);

  gtk_widget_grab_default (ask_button_no);
  return ask_dialog;
}

