#include <gtk/gtk.h>

struct optionstruct {
	GtkWidget *main_window;
	gboolean ShowToolbar;
	gint ToolBarType; /* 0=picture+text 1=pictures 2=text */
	gboolean OpenLast;
	gboolean LineWarp;
	gint TabPos; /* 0=left 1=right 2=top 3=bottom */
	GString *LastOpenedFile;
};

struct optionstruct options;

void read_options(GtkWidget *window, GList *nb_data);
void save_options();
void open_options_window (gint page);
void show_toolbar_toggle (GtkToggleButton *button);
void toolbar_style (gint i);
void options_ok ();
void options_cancel ();
void tabs_pos (gint i);
void line_wrap (gboolean i, GList *nb_data);
